import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GrimDigits.Class";
import "GrimDigits.DigitsWindow";


local player = Turbine.Gameplay.LocalPlayer();
local screenHeight = Turbine.UI.Display.GetHeight();
local screenWidth = Turbine.UI.Display.GetWidth();

HealthDigits = DigitsWindow();
PowerDigits = DigitsWindow();

function HealthDigits:Layout()
	self.settingstable = "GrimHealthDigits"

	self:LoadSettings((screenWidth - (screenWidth * .60)), (screenHeight - (screenHeight * .35)), 1, "Current Long", Turbine.UI.Lotro.Font.TrajanPro23 );
	
	
	self:SetLeft(self.settings.LeftPosition);
	self:SetTop(self.settings.TopPosition);
	
	
	if (self.settings.AlphaChannel == 1 ) then
		self:SetBackColor(Turbine.UI.Color(0.75, 0, 0, 0));
	else
		self:SetBackColor(Turbine.UI.Color(0.0, 0, 0, 0));
	end
	
	
	self.textlayout = self.settings.TextFormat;
	self.textfont = self.settings.TextFont;	
		
	player.MoraleChanged = function( sender, args )
		self:UpdateHealth()
	end
		
	player.MaxMoraleChanged = function( sender, args )
		self:UpdateHealth()
	end
	
	player.BaseMaxMoraleChanged = function( sender, args )
		self:UpdateHealth()
	end
	if (self.DigitsLabel:GetText() == "") then 
		self:UpdateHealth();
	end
end



function HealthDigits:UpdateHealth()
	local health = player:GetMorale();
	local Ihealth = string.format("%i", health);
	

	local maxhealth = player:GetMaxMorale();
	local Imaxhealth = string.format("%i", maxhealth);

	local baseMaxHealth = player:GetBaseMaxMorale();
	local IbaseMaxHealth = string.format("%i", baseMaxHealth);
	
	if (self.textlayout == "Current | Max") then
		self:SetSize(195,50);
		self.DigitsLabel:SetSize(185,40);
	else
		self:SetSize(100,50);
		self.DigitsLabel:SetSize(90,40);
	end
	
	self.DigitsLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	self.DigitsLabel:SetFont( self.textfont );
	self.DigitsLabel:SetText( self:TextFormat(health, maxhealth) );

	local percentHealth = (health / maxhealth);
	local HealthColorA = ((204/255)*(2 - (percentHealth * 2)));
	local HealthColorB = ((1 - (51/255))*percentHealth * 2);
	if  (percentHealth >= 0.5) then		
		self.DigitsLabel:SetForeColor( Turbine.UI.Color(1, (HealthColorA + (51/255)), 1, 102/255 ) );
	else
		self.DigitsLabel:SetForeColor( Turbine.UI.Color(1, 1, (HealthColorB + (51/255)), 102/255 ) );
	end


end


function PowerDigits:Layout()
	self.settingstable = "GrimPowerDigits"

	self:LoadSettings((screenWidth - (screenWidth * .45)), (screenHeight - (screenHeight * .35)), 1, "Current Long", Turbine.UI.Lotro.Font.TrajanPro23 );
	
	self:SetLeft(self.settings.LeftPosition);
	self:SetTop(self.settings.TopPosition);

	
	if (self.settings.AlphaChannel == 0 ) then
		self:SetBackColor(Turbine.UI.Color(0, 0, 0, 0));
	else
		self:SetBackColor(Turbine.UI.Color(0.75, 0, 0, 0));
	end

	self.textlayout = self.settings.TextFormat;
	self.textfont = self.settings.TextFont;
		
	player.PowerChanged = function( sender, args )
		self:UpdatePower()
	end
		
	player.MaxPowerChanged = function( sender, args )
		self:UpdatePower()
	end
	
	player.BaseMaxPowerChanged = function( sender, args )
		self:UpdatePower()
	end
	if (self.DigitsLabel:GetText() == "") then 
		self:UpdatePower();
	end
end



function PowerDigits:UpdatePower()
	local power = player:GetPower();
	local Ipower = string.format("%i", power);

	local maxpower = player:GetMaxPower();
	local Imaxpower = string.format("%i", maxpower);

	local baseMaxPower = player:GetBaseMaxPower();
	local IbaseMaxPower = string.format("%i", baseMaxPower);
	
	if (self.textlayout == "Current | Max") then
		self:SetSize(195,50);
		self.DigitsLabel:SetSize(185,40);
	else
		self:SetSize(100,50);
		self.DigitsLabel:SetSize(90,40);
	end
	
	self.DigitsLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

	self.DigitsLabel:SetFont(self.textfont);
	self.DigitsLabel:SetText( self:TextFormat(power, maxpower) );

	local percentPower = (power / maxpower);
	local PowerColorA = ((204/255)*(2 - (percentPower * 2)));
	local PowerColorB = ((204/255)* percentPower * 2);
	if  (percentPower >= 0.5) then		
		self.DigitsLabel:SetForeColor( Turbine.UI.Color(1, (PowerColorA + (51/255)), 102/255, 1 ));
	else
		self.DigitsLabel:SetForeColor( Turbine.UI.Color(1, 1, 102/255, (PowerColorB + (51/255)) ));
	end


end

function Updates ()
	PowerDigits:UpdatePower();
	HealthDigits:UpdateHealth();
end

function Turbine.Plugin:Unload()
	HealthDigits = nil;
	PowerDigits = nil;
end

HealthDigits:Layout()
PowerDigits:Layout()

Turbine.Shell.WriteLine("GrimDigits v1.0.1 by GrimIron");

